#![allow(deprecated)]
use std::fmt;
use std::str;
/// Supported numeric data types for value casting.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum NumericDataType {
    #[serde(rename = "INT64")]
    Int64,
    #[serde(rename = "FLOAT64")]
    Float64,
    #[serde(rename = "UINT64")]
    Uint64,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl NumericDataType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            NumericDataType::Int64 => "INT64",
            NumericDataType::Float64 => "FLOAT64",
            NumericDataType::Uint64 => "UINT64",
            NumericDataType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for NumericDataType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for NumericDataType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for NumericDataType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<NumericDataType, conjure_object::plain::ParseEnumError> {
        match v {
            "INT64" => Ok(NumericDataType::Int64),
            "FLOAT64" => Ok(NumericDataType::Float64),
            "UINT64" => Ok(NumericDataType::Uint64),
            v => v.parse().map(|v| NumericDataType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for NumericDataType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<NumericDataType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the NumericDataType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
